# Releasing


This document deals with how to make a new release of the ubuntu-repository-cache charm.
While not of general use (most readers probably won't have enough credentials to drive a release),
it serves as a reference for charm publishing and a roadmap for future publishers.

## Steps

1. Make sure all your changes landed in lp:ubuntu-repository-cache. This is the branch
   from which the charm should be published to the charm store on the official
   cs:ubuntu-repository-cache URL.
2. Ideally, tag lp:ubuntu-repository-cache with the expected charm store version:
   "bzr tag charm-revision-XYZ".
3. Push the branche's contents to the charm store. We need to use BZR export here
   to workaround a bug in the "charm" software with regards to merge revisions (https://github.com/juju/charmstore-client/issues/90)
   "bzr export /tmp/ubuntu-repository-cache lp:ubuntu-repository-cache"
   "cd /tmp/ubuntu-repository-cache"
   "charm push . cs:~cloud-images/ubuntu-repository-cache"
   Your charm is now "unpublished", disgregard the URL you got back.
4. Find out what the latest version of the charm is (the one you just pushed):
   "charm list -u cloud-images"
   Note the URL you get back.
4. Release the newly pushed charm to the relevant channel ("stable" for a real
   release, or "candidate", "beta", "edge").
   "charm release cs:ubuntu-repository-cache-XYZ --channel stable"
