# Testing this charm

Testing this charm is done at two levels: unit tests and functional tests.

## Unit testing

Unit testing will run pure-python unit tests on the local code. It can be done
with "make test", or through "tox" (the make target is an alias to tox for
consistency accross charms).

In order to run unit tests you need to have "tox" installed:

    sudo apt-get install tox

## Functional testing

Functional testing is a little more involved, as the charm will be deployed in
a Juju 2 model for real, and will be tested using Amulet.

To run functional tests, you need to run "make functional_test". The necessary
dependencies will be added to your environment, namely a new PPA will be added
and a few debian packages will be installed.

It is recommended to run functional tests from within a container (LXD).

Running the tests require that you bootstrap and create a clean Juju 2 model
before executing the tests. The tests will use the current 'in-focus' model.

The test suite uses a lot of IO, so it is recommended to use a cloud with decent
IO performances (EC2 is suggested).
